api/views/exchange.py
#   datamax/api/views/exchange.py
#   Copyright (C) 2019 Axtria.
#
#   Author: Varun Singhal <varun.singhal@axtria.com>
from flask import Blueprint, render_template

views_exchange = Blueprint('views_exchange', __name__)


@views_exchange.route('/login')
def login():
    """

    Returns:

    """
    return render_template('api_exchange/login.html')


@views_exchange.route('/add')
def add_api():
    """API Exchange - add APIs into the system using the user interface.

    Returns:

    """
    return render_template('api_exchange/add.html')


@views_exchange.route('/published')
def published_api():
    """

    Returns:

    """
    return render_template('api_exchange/published.html')


@views_exchange.route('/all')
def all_api():
    """

    Returns:

    """
    return render_template('api_exchange/all.html')


@views_exchange.route('/edit')
def edit_api():
    """

    Returns:

    """
    return render_template('api_exchange/edit.html')


@views_exchange.route('/copy')
def copy_api():
    """

    Returns:

    """
    return render_template('api_exchange/copy.html')


@views_exchange.route('/category')
def category_api():
    """

    Returns:

    """
    return render_template('api_exchange/category.html')


@views_exchange.route('/summary')
def summary_api():
    """

    Returns:

    """
    return render_template('api_exchange/summary.html')

api/templates/api_exchange/add.html
{# _datamax/api/templates/api_exchange/add.html_ #}
{% extends "api_exchange_layout.html" %}

{% block body %}
<a class="card-link" href="#">
    <h5 class="card-title">Add API to the system</h5>
</a>
<br/>
<form method="post" action="{{ url_for('api_exchange.index') }}" id="addAPIform">
    <input type="hidden" name="name" value="add_api">
    <input type="hidden" name="sequence" value="1">

    <div class="form-group">
        <label for="name">API Name</label>
        <input type="text" class="form-control" id="name" placeholder="" name="api_name">
        <small id="nameHelp" class="form-text text-muted">
            API name has to be unique.
        </small>
    </div><!-- .name -->
    <div class="form-group">
        <label for="description">Description</label>
        <input type="text" class="form-control" id="description" placeholder="" name="description" required>
        <small id="descriptionHelp" class="form-text text-muted">
        </small>
    </div><!-- .description -->
    <div class="form-group">
        <label for="connection">Connection</label>
        <select class="form-control" id="connection" name="connector_id">

        </select>
        <small id="connectionHelp" class="form-text text-muted">
        </small>
    </div><!-- .connection -->
    <div class="form-group">
        <label for="query">Query</label>
        <textarea class="form-control" id="query" name="query" placeholder="select * from my_table where name = %(param_name)s"></textarea>
        <small id="queryHelp" class="form-text text-muted">
            Use named parameters as per the PEP 249 guidelines. Example: %(param_name)s, %(id)s.
        </small>
    </div><!-- .query -->
    <div class="form-group">
        <label for="category">Category</label>
        <input type="text" class="form-control" id="category" placeholder="" name="category" required>
    </div><!-- .category -->
    <div class="form-group">
        <label for="status">Status</label>
        <input type="text"  class="form-control" name="status" value="pending" readonly id="status">
        <small id="statusHelp" class="form-text text-muted">
            You will need to approve the API to use it in the project.
        </small>
    </div><!-- .status -->
    <input type="submit" class="btn btn-primary float-right" name="submit" value="Add">
    <div class="loading float-right"></div>

</form>

<script>
    $(document).ready(function(){
        $.ajax({
            type: "GET",
            url: "{{ url_for('api_exchange.index') }}",
            data: 'name=all_connections',
            success: function(data){
              $.each(data.Contents, function(index, val){
                $("#connection").append('<option value="' + val.id + '">' + val.name + '</option>');
              });
            }
        });
    });

    $("#addAPIform").submit(function() {
        $.ajax({
         type: "POST",
         url: $(this).attr('action'),
         data: $(this).serialize(),
         success: function(data) {
                console.log(data);
                window.location.href = "{{ url_for('views_exchange.all_api') }}";
         }
       });
       return false;
    });
</script>

{% endblock %}

api/templates/api_exchange/all.html
{# _datamax/api/templates/api_exchange/all.html_ #}
{% extends "api_exchange_layout.html" %}

{% block body %}
<a class="card-link" href="#">
    <h5 class="card-title">All APIs in the system</h5>
</a>
<br/>

<table id="Content" class="display" style="width:100%">
<thead>
    <tr>
        <td>Name</td>
        <td>Version</td>
        <td>Description</td>
        <td>Query</td>
        <td>Connection</td>
        <td>Category</td>
        <td>Status</td>
        <td>Created on</td>
        <td>Action</td>
    </tr>
</thead>
</table>

<script>
    $(document).ready(function() {
        $('#Content').DataTable({
             "stateSave": true,
             "ordering": false,
             "ajax": {
                url: "{{ url_for('api_exchange.index') }}" + "?name=all_api",
                dataSrc: 'Contents'
             },
             "columns": [
                { data: "name", "width": "10%" },
                { data: "version", "width": "5%" },
                { data: "description", "width": "15%" },
                { data: "query", "width": "30%"},
                { data: "connection_name"},
                { data: "category"},
                { data: "status", "width": "7%"},
                { data: "created_on" },
                { "data": null, "width": "10%" }
             ],
             columnDefs: [{
                // puts a button in the last column
                targets: [-1], render: function (a, b, data, d) {
                    if (data.status == 'pending') {
                        return '<a href="{{ url_for('views_exchange.edit_api') }}?id=' + data.id + '"><i class="fas fa-edit"></i></a>' +
                               '&ensp;&ensp;<a href="{{ url_for('api_exchange.index') }}?name=approve_api&id=' + data.id + '&api_name=' + data.name + '" class="approve-api">' +
                               '<i class="fas fa-check-square"></i></a>&ensp;&ensp;' +
                               '<a href="{{ url_for('api_exchange.index') }}?name=reject_api&id=' + data.id + '" class="reject-api">' +
                               '<i class="fas fa-times-circle"></i></a>' +
                               '&ensp;&ensp;<a href="{{ url_for('views_exchange.copy_api') }}?id='+ data.id +'"><i class="far fa-copy"></i></a>';
                    } else if (data.status == 'published') {
                        return '<a href="{{ url_for('views_exchange.edit_api') }}?id=' + data.id + '"><i class="fas fa-edit"></i></a>' +
                               '&ensp;&ensp;<a href="{{ url_for('api_exchange.index') }}?name=reject_api&id=' + data.id + '" class="reject-api">' +
                               '<i class="fas fa-times-circle"></i></a>' +
                               '&ensp;&ensp;<a href="{{ url_for('views_exchange.copy_api') }}?id='+ data.id +'"><i class="far fa-copy"></i></a>';
                    }else if (data.status == 'rejected') {
                        return '<a href="{{ url_for('views_exchange.edit_api') }}?id=' + data.id + '"><i class="fas fa-edit"></i></a>' +
                               '&ensp;&ensp;<a href="{{ url_for('views_exchange.copy_api') }}?id='+ data.id +'"><i class="far fa-copy"></i></a>';
                    }
                    return "";
                }
            }]
      });

      $("#Content").on('click', '.approve-api, .reject-api', function(){
            console.log("requesting .... " + $(this).attr('href'));
            $.ajax({
                 type: "GET",
                 url: $(this).attr('href'),
                 success: function(data) {
                        console.log(data);
                        window.location.href = "./all";
                 },
                 fail: function(data) {
                        console.log(data);
                 }
           });
           return false;
      });
} );
</script>
{% endblock %}

api/templates/api_exchange/category.html
{# _datamax/api/templates/api_exchange/add.html_ #}
{% extends "api_exchange_layout.html" %}

{% block body %}
<a class="card-link" href="#">
    <h5 class="card-title">API Summary&ensp;&ensp;
        <a tabindex="0" role="button" data-toggle="popover"
           data-trigger="focus" data-html="true" title="How this works?"
           data-content="Categories are identified based on the input provided while creating new APIs. <br/>
                         <b>WIP</b>: <code>Controller</code> based API identification.">
            <i class="fas fa-info-circle"></i>
        </a>
    </h5>
</a>
<br/>


<div class="category row">

</div>


<script>
    $(document).ready(function(){
         $('[data-toggle="popover"]').popover();

        $.ajax({
            type: "GET",
            url: "{{ url_for('api_exchange.list_category') }}",
            data: '',
            success: function(data){
              $.each(data.Contents, function(index, val){
                $(".category").append('<div class="col-md-2 mb-4"><div class="card">\
                <a href="{{ url_for('views_exchange.summary_api') }}?name=' + val.category + '">\
                <img src="https://ui-avatars.com/api/?name=' + val.category + '&size=512&background=EEE9E9" alt="' + val.category + '" class="img-thumbnail">\
                </a>\
                <div class="card-body">\
                <p class="card-text">' + val.category + ' (' + val.count + ') </p>\
                </div>\
                </div></div>');
              });
            }
        });
    });
</script>

{% endblock %}

api/templates/api_exchange/copy.html
{# _datamax/api/templates/api_exchange/copy.html_ #}
{% extends "api_exchange_layout.html" %}

{% block body %}
<a class="card-link" href="#">
    <h5 class="card-title">Copy API</h5>
</a>

<br/>
<form method="post" action="{{ url_for('api_exchange.index') }}" id="addAPIform">
    <input type="hidden" name="name" value="add_api">
    <input type="hidden" name="sequence" value="1">

    <div class="form-group">
        <label for="name">API Name</label>
        <input type="text" class="form-control" id="name" placeholder="" name="api_name">
        <small id="nameHelp" class="form-text text-muted">
            API name has to be unique.
        </small>
    </div><!-- .name -->
    <div class="form-group">
        <label for="description">Description</label>
        <input type="text" class="form-control" id="description" placeholder="" name="description">
        <small id="descriptionHelp" class="form-text text-muted">
        </small>
    </div><!-- .description -->
    <div class="form-group">
        <label for="connection">Connection</label>
        <select class="form-control" id="connection" name="connector_id">

        </select>
        <small id="connectionHelp" class="form-text text-muted">
        </small>
    </div><!-- .connection -->
    <div class="form-group">
         <label for="query">Query</label>
        <textarea class="form-control" id="query" name="query" placeholder="select * from my_table where name = %(param_name)s"></textarea>
        <small id="queryHelp" class="form-text text-muted">
            Use named parameters as per the PEP 249 guidelines. Example: %(param_name)s, %(id)s.
        </small>
    </div><!-- .query -->
    <div class="form-group">
        <label for="category">Category</label>
        <input type="text" class="form-control" id="category" placeholder="" name="category">
    </div><!-- .category -->
    <div class="form-group">
        <label for="status">Status</label>
        <input type="text"  class="form-control" name="status" value="pending" readonly id="status">
        <small id="statusHelp" class="form-text text-muted">
            You will need to approve the API to use it in the project.
        </small>
    </div><!-- .status -->
    <input type="submit" class="btn btn-primary float-right" name="submit" value="Add">
    <div class="loading float-right"></div>

</form>

<script>

    $(document).ready(function(){
        var id = {{ request.args.get('id') }};
        console.log(id);
        $.ajax({
            type:"POST",
            url: "{{ url_for('api_exchange.index') }}",
            data: 'name=get_api&id='+ id,
            success: function(data) {
                console.log(data);
                $("#name").val('Copy_of_' + data.Contents[0].name);
                $("#query").val(data.Contents[0].query);
                $("#description").val(data.Contents[0].description);
                $("#category").val(data.Contents[0].category);
                var connection_id = data.Contents[0].connection_id;
                $.ajax({
                    type: "GET",
                    url: "{{ url_for('api_exchange.index') }}",
                    data: 'name=all_connections',
                    success: function(data){
                      $.each(data.Contents, function(index, val){
                        var selected = (val.id == connection_id) ? 'selected': '';
                        $("#connection").append('<option value="' + val.id + '" ' + selected + '>' + val.name + '</option>');
                      });
                    }
                }); // second ajax request
            }
        });

    });

    $("#addAPIform").submit(function() {
        $.ajax({
         type: "POST",
         url: $(this).attr('action'),
         data: $(this).serialize(),
         success: function(data) {
                console.log(data);
                window.location.href = "./all";
         }
       })
       return false;
  })
</script>

{% endblock %}

api/templates/api_exchange/edit.html
{# _datamax/api/templates/api_exchange/edit.html_ #}
{% extends "api_exchange_layout.html" %}

{% block body %}
<a class="card-link" href="#">
    <h5 class="card-title">Edit API</h5>
</a>

<br/>
<form method="post" action="{{ url_for('api_exchange.index') }}" id="addAPIform">
    <input type="hidden" name="name" value="edit_api">
    <input type="hidden" name="sequence" value="1">

    <div class="form-group">
        <label for="name">API Name</label>
        <input type="text" class="form-control" id="name" placeholder="" name="api_name" readonly>
        <small id="nameHelp" class="form-text text-muted">
            API name has to be unique.
        </small>
    </div><!-- .name -->
    <div class="form-group">
        <label for="description">Description</label>
        <input type="text" class="form-control" id="description" placeholder="" name="description">
        <small id="descriptionHelp" class="form-text text-muted">
        </small>
    </div><!-- .description -->
    <div class="form-group">
        <label for="connection">Connection</label>
        <select class="form-control" id="connection" name="connector_id">

        </select>
        <small id="connectionHelp" class="form-text text-muted">
        </small>
    </div><!-- .connection -->
    <div class="form-group">
        <label for="query">Query</label>
        <textarea class="form-control" id="query" name="query" placeholder="select * from my_table where name = %(param_name)s"></textarea>
        <small id="queryHelp" class="form-text text-muted">
            Use named parameters as per the PEP 249 guidelines. Example: %(param_name)s, %(id)s.
        </small>
    </div><!-- .query -->
    <div class="form-group">
        <label for="category">Category</label>
        <input type="text" class="form-control" id="category" placeholder="" name="category">
    </div><!-- .category -->
    <div class="form-group">
        <label for="status">Status</label>
        <input type="text"  class="form-control" name="status" value="pending" readonly id="status">
        <small id="statusHelp" class="form-text text-muted">
            You will need to approve the API to use it in the project.
        </small>
    </div><!-- .status -->
    <input type="submit" class="btn btn-primary float-right" name="submit" value="Add">
    <div class="loading float-right"></div>

</form>

<script>

    $(document).ready(function(){
        var id = {{ request.args.get('id') }};
        console.log(id);
        $.ajax({
            type:"POST",
            url: "{{ url_for('api_exchange.index') }}",
            data: 'name=get_api&id='+ id,
            success: function(data) {
                console.log(data);
                $("#name").val(data.Contents[0].name);
                $("#query").val(data.Contents[0].query);
                $("#description").val(data.Contents[0].description);
                $("#category").val(data.Contents[0].category);
                var connection_id = data.Contents[0].connection_id;
                $.ajax({
                    type: "GET",
                    url: "{{ url_for('api_exchange.index') }}",
                    data: 'name=all_connections',
                    success: function(data){
                      $.each(data.Contents, function(index, val){
                        var selected = (val.id == connection_id) ? 'selected': '';
                        $("#connection").append('<option value="' + val.id + '" ' + selected + '>' + val.name + '</option>');
                      });
                    }
                }); // second ajax request
            }
        });

    });

    $("#addAPIform").submit(function() {
        $.ajax({
         type: "POST",
         url: $(this).attr('action'),
         data: $(this).serialize(),
         success: function(data) {
                console.log(data);
                window.location.href = "./all";
         }
       })
       return false;
  })
</script>

{% endblock %}

api/templates/api_exchange/login.html
{# _datamax/api/templates/api_exchange/login.html_ #}
{% extends "public_layout.html" %}

{% block body %}
<div class="col-md-4"></div>
<div class="col-md-4">
    <!--- \\\\\\\Post-->
    <div class="card gedf-card" style="margin-top:35%">
        <div class="card-body text-center">
            <form class="form-signin" action="#" id="signInForm">
                <h4 class="h4 mb-4">API Exchange</h4>
                <label for="inputModuleName" class="sr-only">Module name</label>
                <input type="text" id="inputModuleName" class="form-control" placeholder="Module name"
                       name="module_name" required>
                <br>
                <label for="inputPassword" class="sr-only">Password</label>
                <input type="password" id="inputPassword" class="form-control" placeholder="Password" name="password"
                       required>
                <br>
                <input class="btn btn-primary btn-block" value="Sign in" type="submit">
                <p class="mt-5 mb-3 text-muted">&copy; 2019 Axtria.</p>
            </form>
        </div> <!-- .card body ends-->
    </div>
    <!-- Post /////-->
</div>
<div class="col-md-4"></div>
<script>
    $("#signInForm").submit(function() {
        $.ajax({
         type: "POST",
         url: "{{ url_for('api_exchange.authorize') }}",
         data: $(this).serialize(),
         success: function(data) {
                console.log(data);
                window.location.href = "{{ url_for('views_exchange.category_api') }}";
         }
       })
       return false;
  })
</script>
{% endblock %}

api/templates/api_exchange/published.html
{# _datamax/api/templates/api_exchange/all.html_ #}
{% extends "api_exchange_layout.html" %}

{% block body %}
<a class="card-link" href="#">
    <h5 class="card-title">Published APIs in the system</h5>
</a>
<br/>

<table id="Content" class="display" style="90%">
<thead>
    <tr>
        <td>Id</td>
        <td>Name</td>
        <td>Version</td>
        <td>Description</td>
        <td>Query</td>
        <td>Connection</td>
        <td>Category</td>
        <td>Status</td>
        <td>Created On</td>
    </tr>
</thead>
</table>

<script>
    $(document).ready(function() {
        $('#Content').DataTable({
            "autoWidth": false,
             "stateSave": true,
             "ordering": false,
             "ajax": {
                url: "{{ url_for('api_exchange.index') }}" + "?name=published_api",
                dataSrc: 'Contents',
             },
             "columns": [
                { data: "id"},
                { data: "name" },
                { data: "version" },
                { data: "description", "width": "20%"},
                { data: "query", "width": "30%"},
                { data: "connection_name"},
                { data: "category"},
                { data: "status"},
                { data: "created_on"}
             ],
             "columnDefs": [
                {"targets": [0],"visible": false}
             ],
             dom: 'Bfrtip',
            buttons: [
                'copy', 'csv', 'excel', 'pdf', 'print'
            ]

        });
    });
</script>
{% endblock %}

api/templates/api_exchange/summary.html
{# _datamax/api/templates/api_exchange/summary.html_ #}
{% extends "api_exchange_layout.html" %}

{% block body %}
<a class="card-link" href="#">
    <h5 class="card-title">Summary of APIs - {{ request.args.get('name') }}</h5>
</a>
<br/>

<table id="Content" class="display" style="90%">
<thead>
    <tr>
        <td>Id</td>
        <td>Name</td>
        <td>Description</td>
        <td>Parameters</td>
        <td>Output</td>
        <td>API URL</td>
    </tr>
</thead>
</table>

<script>
    $(document).ready(function() {

        var baseURL =  window.location.href.substr(0, window.location.href.indexOf('views/'));

        $('#Content').DataTable({
            "autoWidth": false,
             "stateSave": true,
             "ordering": false,
             "ajax": {
                url: "{{ url_for('api_exchange.summary') }}?name={{ request.args.get('name') }}",
                dataSrc: 'Contents',
             },
             "columns": [
                { data: "id"},
                { data: "name", "width": "20%"},
                { data: "description", "width": "20%"},
                { data: "parameters", "width": "20%"},
                { data: "output"},
                { data: null}
             ],
             columnDefs: [{
                // puts a button in the last column
                targets: [-1], render: function (a, b, data, d) {
                    return baseURL + "api/exchange?name=" + data.name + data.url;
                }
            }],
            dom: 'Bfrtip',
            buttons: [
                'copy', 'csv', 'excel', 'pdf', 'print'
            ]

        });
    });
</script>
{% endblock %}